"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

LookupKey subclass:#Association
       instanceVariableNames:'value'
       classVariableNames:''
       poolDictionaries:''
       category:'Collections-Support'
!

Association comment:'
COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

$Header: /claus/smalltalk/st/libbasic/RCS/Assoc.st,v 1.10 94/10/10 00:19:42 claus Exp $
'!

!Association class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /claus/smalltalk/st/libbasic/RCS/Assoc.st,v 1.10 94/10/10 00:19:42 claus Exp $
"
!

documentation
"
    Associations are a key-value pair; conceptionally, they are the elements of 
    Dictionaries - storing value under the key. (However, the real implementation
    of Dictionary is different).
    Taken by itself, an association is not very useful.

    Instance variables:

        key             <Object>        the key (inherited)
        value           <Object>        the value
"
! !

!Association class methodsFor:'instance creation'!

key:aKey value:aValue
    "return a new Association"

    ^ self basicNew key:aKey value:aValue
! !

!Association methodsFor:'accessing'!

value
    "return the value of the association"

    ^ value
!

value:anObject
    "set the value of the receiver to be anObject.
     Return the receiver"

    value := anObject
!

key:aKey value:aValue
    "set both the key and value of the receiver.
     Return the receiver"

    key := aKey.
    value := aValue
! !

!Association methodsFor:'comparing'!

= anAssociation
    "return true if the receiver equals the argument.
     Notice, that this compares both key AND value.
     Time will show if this is ok."

    self species == anAssociation species ifTrue:[
        (anAssociation key = key) ifTrue:[
            ^ anAssociation value = value
        ]
    ].
    ^ false
!

hash
    "return an integer useful for hashing on the receiver;
     redefined since = is redefined here."

    ^ (key hash) bitXor:(value hash)
! !

!Association methodsFor:'printing & storing'!

printOn:aStream
    "return a string containing a printable representation
     of the receiver"

    key printOn:aStream.
    aStream nextPutAll:'->'.
    value printOn:aStream
!

displayString
    "return a string containing a printable representation
     of the receiver for displaying - redefined to use display string on
     the components for nicer look"

    ^ key displayString , '->' , value displayString
! !
