"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

GLXView subclass:#GLDemo1
	 instanceVariableNames:'redrawProcess'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Demos-3D'
!

GLDemo1 comment:'
simple GL demo - see class method #documentation
'!

!GLDemo1 class methodsFor:'documentation'!

documentation
"
    a very simple GL view;
    sets up a transformation and draws a simple 2D figure.

    startup:
	GLDemo1 open
"
! !

!GLDemo1 class methodsFor:'defaults'!

defaultExtent
    "used by superclasses open-method"

    ^ 300 @ 300
!

defaultLabel
    "used by superclasses open-method"

    ^ 'simple GL'
! !

!GLDemo1 methodsFor:'drawing'!

redraw 
    "
     define perspective-viewing
	0.0                                   200.0
    eye                                   
	near                                  far
    <)  -------------+------+-----------------+-------------------+
		     \      \                  \                   \
		      \      \                  \                   \
		       \      \                  \                   \
			+------+                  \                   \
						   \                   \
						    \                   \
						     \                   \
						      \                   \
						       +-------------------+

	 ---> negative z coordinates
    "

    self perspectiveFovy:450 aspect:1.0 near:0.0 far:200.0. 

    "
     clear the drawing area
    "
    self color:Black.    "Black is a class variable in GLXView"
    self clear.          "clear to current color"

    "
     save current transformation
    "
    self pushMatrix.

    "
     the rectangle is at 0.0/0.0/-20.0
    "
    self translateX:0.0 y:0.0 z:-20.0.

    "
     draw a rectangle
    "
    self color:White.
    self beginClosedLine.
    self v3f:#(-1.0 -1.0 0.0).
    self v3f:#( 1.0 -1.0 0.0).
    self v3f:#( 1.0  1.0 0.0).
    self v3f:#(-1.0  1.0 0.0).
    self endClosedLine.

    "
     restore transformation
    "
    self pushMatrix.
! !

!GLDemo1 methodsFor:'initialization'!

initialize
    super initialize.
    "
     define the type of view;
	VGL supports #colorIndexSingleBuffer
		 and #colorIndexDoubleBuffer

	real GL additionaly supports
		     #rgbSingleBuffer
		 and #rgbDoubleBuffer
    "
    "
     this will work on any ...
    "
    type := #colorIndexSingleBuffer.
!

realize
    super realize.

    "startup a redraw process"

    redrawProcess := [
	[true] whileTrue:[
		self redraw.
		(Delay forSeconds:(1/10)) wait.
	]
    ] forkAt:4
!

destroy
    "stop the redraw process"
    redrawProcess notNil ifTrue:[
	redrawProcess terminate.
	redrawProcess := nil
    ].
    super destroy
! !

