"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

GLXView subclass:#GLDemo4
	 instanceVariableNames:'redrawProcess rotation'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Demos-3D'
!

GLDemo4 comment:'
simple GL demo - see class method #documentation
'!

!GLDemo4 class methodsFor:'documentation'!

documentation
"
    a very simple GL view;
    same as demo3, but adds double-buffering for smoother drawing

    startup:
	GLDemo4 open
"
! !

!GLDemo4 class methodsFor:'defaults'!

defaultExtent
    "used by superclass"

    ^ 300 @ 300
!

defaultLabel
    "used by superclasses open-method"

    ^ 'GL: rotation around y'
! !

!GLDemo4 methodsFor:'drawing'!

redraw 
    "
     define perspective-viewing
	0.0                                   200.0
    eye                                   
	near                                  far
    <)  -------------+------+-----------------+-------------------+
		     \      \                  \                   \
		      \      \                  \                   \
		       \      \                  \                   \
			+------+                  \                   \
						   \                   \
						    \                   \
						     \                   \
						      \                   \
						       +-------------------+

	 ---> negative z coordinates
    "

    self perspectiveFovy:450 aspect:1.0 near:0.0 far:200.0. 

    "
     zoom into z
    "
    self translateX:0 y:0 z:5.0.

    "
     clear the drawing area
    "
    self color:Black.    
    self clear.        


    "------------- white rectangle -----------------"

    "
     save current rotation/translation
    "
    self pushMatrix.

    self translateX:0.0 y:0.0 z:-20.

    "
     rotate around y-axis
    "
    self rotateX:0.0 y:rotation z:0.0.
    rotation := rotation + 3.0.

    self color:White.
    self beginClosedLine.
    self v3f:#(-1.0 -1.0 0.0).
    self v3f:#( 1.0 -1.0 0.0).
    self v3f:#( 1.0  1.0 0.0).
    self v3f:#(-1.0  1.0 0.0).
    self endClosedLine.

    self popMatrix.

    "------------- yellow rectangle -----------------"

    self pushMatrix.
    self translateX:0.0 y:0.0 z:-50.

    self color:Yellow.
    self beginClosedLine.
    self v3f:#(-1.0 -1.0 0.0).
    self v3f:#( 1.0 -1.0 0.0).
    self v3f:#( 1.0  1.0 0.0).
    self v3f:#(-1.0  1.0 0.0).
    self endClosedLine.

    self popMatrix.

    self swapBuffers
! !

!GLDemo4 methodsFor:'initialization'!

initialize
    super initialize.
    "
     define the type of view;
	VGL supports #colorIndexSingleBuffer
		 and #colorIndexDoubleBuffer

	real GL additionaly supports
		     #rgbSingleBuffer
		 and #rgbDoubleBuffer
    "
    "
     this will work on any ...
    "
    type := #colorIndexDoubleBuffer.

    rotation := 0.0
!

realize
    super realize.

    "startup a redraw process"

    redrawProcess := [
	[true] whileTrue:[
		self redraw.
		(Delay forSeconds:(1/10)) wait.
	]
    ] forkAt:4
!

destroy
    "stop the redraw process"
    redrawProcess notNil ifTrue:[
	redrawProcess terminate.
	redrawProcess := nil
    ].
    super destroy
! !





