"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

EditField subclass:#FilenameEditField 
       instanceVariableNames:''
       classVariableNames:   ''
       poolDictionaries:''
       category:'Views-Text'
!

FilenameEditField comment:'
COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

$Header: /claus/smalltalk/st/libwidg2/RCS/FNmEdtFld.st,v 1.7 95/02/06 00:57:37 claus Exp $
'!

!FilenameEditField class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /claus/smalltalk/st/libwidg2/RCS/FNmEdtFld.st,v 1.7 95/02/06 00:57:37 claus Exp $
"
!

documentation
"
    like a normal editField, but does filename-completion on the last word of
    the contents, when TAB is pressed.
"
! !

!FilenameEditField methodsFor:'initialization'!

realize
    "move the cursor to the end - thats the most interresting part of
     a filename
    "
    super realize.
    self cursorToEndOfLine.
! !

!FilenameEditField methodsFor:'accessing'!

initialText:aString selected:aBoolean
    "move the cursor to the end - thats the most interresting part of
     a filename
    "

    super initialText:aString selected:aBoolean.
    self cursorToEndOfLine.
! !

!FilenameEditField methodsFor:'event handling'!

keyPress:key x:x y:y
    "handle tab for filename completion"

    |s f matchSet nMatch name words|

    enabled ifTrue:[
	key == #Tab ifTrue:[
	    s := self contents.
	    "
	     find the last word ...
	    "
	    words := s asCollectionOfWords.
	    f := words last asFilename.
	    matchSet := f filenameCompletion.
	    (nMatch := matchSet size) ~~ 1 ifTrue:[
		"
		 more than one possible completion -
		"
		self changed:#directory with:f directory.
		device beep
	    ].
	    "
	     even with more than one possible completion,
	     f's name is now common prefix
	    "
	    name := f asString.
	    nMatch == 1 ifTrue:[
		"
		 exactly one possible completion -
		"
		f isDirectory ifTrue:[
		    (name endsWith:(Filename separator)) ifFalse:[
			name := (f construct:'') asString
		    ].
		].
	    ].
	    "
	     construct new contents, by taking
	     last words completion
	    "
	    s := ''.
	    1 to:(words size - 1) do:[:idx |
		s := s , (words at:idx) , ' '
	    ].
	    s := s , name.
	    self contents:s.
	    self cursorToEndOfLine.
	    ^ self
	].
    ].
    ^ super keyPress:key x:x y:y.
! !


