'From Smalltalk/X, Version:2.10.4 on 26-dec-1994 at 6:40:00 pm'!

GLObjectDemoView subclass:#GLBrickDemoView
	 instanceVariableNames:''
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Demos-3D'
!

!GLBrickDemoView class methodsFor:'documentation'!

documentation
"
    this is an adaption of an SGI example (in chapter18 of the manual).
    Draws a plane with brick-pattern as texture.
"
! !

!GLBrickDemoView class methodsFor:'defaults'!

defaultLabel
    ^ 'GL textured plane'
! !

!GLBrickDemoView methodsFor:'drawing'!

drawFrame
    self colorRed:16rCC green:16rCC blue:16rCC alpha:16rFF.
    self beginPolygon.

    self t2f:(FloatArray withAll:#(0.0 0.0)).
    self v3f:(FloatArray withAll:#(-2.0 -4.0 0.0)).

    self t2f:(FloatArray withAll:#(16.0 0.0)).
    self v3f:(FloatArray withAll:#( 2.0 -4.0 0.0)).

    self t2f:(FloatArray withAll:#(16.0 32.0)).
    self v3f:(FloatArray withAll:#( 2.0  4.0 0.0)).

    self t2f:(FloatArray withAll:#(0.0 32.0)).
    self v3f:(FloatArray withAll:#(-2.0  4.0 0.0)).

    self endPolygon.

! !

!GLBrickDemoView methodsFor:'initialization'!

setupPoints
    ^ self
!

mapped 
    |textureBits textureProps texenvProps|

    super mapped .

    textureBits := #[16r00 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF
		     16r00 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF
		     16r00 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF 16rFF
		     16r00 16r00 16r00 16r00 16r00 16r00 16r00 16r00
		     16rFF 16rFF 16rFF 16rFF 16r00 16rFF 16rFF 16rFF
		     16rFF 16rFF 16rFF 16rFF 16r00 16rFF 16rFF 16rFF
		     16rFF 16rFF 16rFF 16rFF 16r00 16rFF 16rFF 16rFF
		     16r00 16r00 16r00 16r00 16r00 16r00 16r00 16r00].

    textureProps := FloatArray withAll:
		    #(16r100.0     "TX_MINFILTER"
		      16r110.0     "TX_POINT"
		      16r200.0     "TX_MAGFILTER"
		      16r110.0     "TX_POINT"
		      16r300.0     "TX_WRAP"
		      16r301.0     "TX_REPEAT"
			0.0     "TX_NULL"
		     ).

    texenvProps := FloatArray withAll:
		    #(16r200.0     "TV_COLOR"
			  0.75 0.13 0.06 1.0
		      16r102.0     "TV_BLEND"
		      0.0       "TV_NULL").

    self texdef2d:1 
	       nc:1
	    width:8
	   height:8
	     bits:textureBits
	       np:0 
	    props:textureProps.
    self tevdef:1 np:0 props:texenvProps.
    self texbind:#texture0 index:1.
    self tevbind:#env0 index:1.


!

initialize
    super initialize.
    type := #rgbDoubleBuffer.

!

drawObject 
    ^ self
!

setupViewing
    self perspectiveFovy:600 aspect:1.0 near:1.0 far:100.0.


! !

