"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

'From Smalltalk/X, Version:2.10.2 on 23-may-1994 at 13:22:58'!

GLObjectDemoView subclass:#GLCubeDemoView
	 instanceVariableNames:''
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Demos-3D'
!

GLCubeDemoView comment:'
a simple solid cube.

start with:
    GLCubeDemoView open
'!

!GLCubeDemoView class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /claus/smalltalk/st/clients/GLdemos/RCS/GLCubeDemo.st,v 1.4 94/11/21 17:28:58 claus Exp $
"
!

documentation
"
    a concrete objectDemo class.
    Draws the cube once (during init) to define it as a GL object.
    Then, in regular intervals, the object is simply called for 
    where a rotation is performed with each animation step.
    All of this is done n the superclass.

    start with:
	GLCubeDemoView open
"
! !

!GLCubeDemoView class methodsFor:'defaults'!

defaultLabel
    "used by superclass"

    ^ 'GL solid cube'
! !

!GLCubeDemoView methodsFor:'drawing'!

drawObject
    self backFace:true.

    "
	    p5------p6
	   /|      /|
	  / |     / |
	 /  |    /  |
	p1------p2  |
	|   |   |   |
	|   p8--|---p7
	|  /    |  /
	| /     | /
	|/      |/
	p4------p3
    "

    "front side"
    self color:White.
    self beginPolygon.  
    self v3f:(points at:1).
    self v3f:(points at:2).
    self v3f:(points at:3).
    self v3f:(points at:4).
    self endPolygon. 

    "back side"
    self color:Green.
    self beginPolygon. 
    self v3f:(points at:6).
    self v3f:(points at:5).
    self v3f:(points at:8).
    self v3f:(points at:7).
    self endPolygon. 

    "right side"
    self color:Red.
    self beginPolygon. 
    self v3f:(points at:2).
    self v3f:(points at:6).
    self v3f:(points at:7).
    self v3f:(points at:3).
    self endPolygon. 

    "left side"
    self color:Yellow.
    self beginPolygon. 
    self v3f:(points at:1).
    self v3f:(points at:4).
    self v3f:(points at:8).
    self v3f:(points at:5).
    self endPolygon. 

    "top side"
    self color:Magenta.
    self beginPolygon. 
    self v3f:(points at:3).
    self v3f:(points at:7).
    self v3f:(points at:8).
    self v3f:(points at:4).
    self endPolygon. 

    "bottom side"
    self color:Blue.
    self beginPolygon. 
    self v3f:(points at:1).
    self v3f:(points at:5).
    self v3f:(points at:6).
    self v3f:(points at:2).
    self endPolygon. 
! !

!GLCubeDemoView methodsFor:'initialization'!

setupPoints
    "
     setup the 8 points:


	    p5------p6
	   /|      /|
	  / |     / |
	 /  |    /  |
	p1------p2  |
	|   |   |   |
	|   p8--|---p7
	|  /    |  /
	| /     | /
	|/      |/
	p4------p3
    "

    points := Array new:8.
    points at:1 put:(Point3D x:-1.0 y:-1.0 z: 1.0).   "front"
    points at:2 put:(Point3D x: 1.0 y:-1.0 z: 1.0).   
    points at:3 put:(Point3D x: 1.0 y: 1.0 z: 1.0).   
    points at:4 put:(Point3D x:-1.0 y: 1.0 z: 1.0).   
    points at:5 put:(Point3D x:-1.0 y:-1.0 z:-1.0).   "rear"
    points at:6 put:(Point3D x: 1.0 y:-1.0 z:-1.0).   
    points at:7 put:(Point3D x: 1.0 y: 1.0 z:-1.0).   
    points at:8 put:(Point3D x:-1.0 y: 1.0 z:-1.0).  
! !

