"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

'From Smalltalk/X, Version:2.10.4 on 26-dec-1994 at 4:26:04 pm'!

GLObjectDemoView subclass:#GLOctaHedronDemoView
	 instanceVariableNames:'colors'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Demos-3D'
!

!GLOctaHedronDemoView class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /claus/smalltalk/st/clients/GLdemos/RCS/GLOctaHedronDemoView.st,v 1.1 95/02/11 17:07:48 claus Exp $
"
!

documentation
"
    a concrete objectDemo class.
    This code is an adaption of an example provided by SGI.
    It requires rgb and zBuffer support - therefore, it will not run
    in VGL configurations (i.e. requires full GL).

    start with:
	GLOctaHedronDemoView open
"
! !

!GLOctaHedronDemoView class methodsFor:'defaults'!

defaultLabel
    ^ 'GL coloured octahedron'
! !

!GLOctaHedronDemoView class methodsFor:'startup'!

open 
    "check if display has rgb and zBuffer features"

    (Display supportsRGB not
    or:[Display supportsZBuffer not
    or:[Display supportsDoubleBuffer not]]) ifTrue:[
	self warn:'sorry, but this demo requires SGI hardware'
    ] ifFalse:[
	^ super open
    ]

    "
     GLOctaHedronDemoView open
    "
! !

!GLOctaHedronDemoView methodsFor:'initialization'!

setupColors
    "
     setup the 6 colors:
    "

    colors := Array new:6.
    colors at:1 put:#(255   0   0).  
    colors at:2 put:#(  0 255   0).   
    colors at:3 put:#(  0   0 255).   
    colors at:4 put:#(255   0 255).   
    colors at:5 put:#(255 255   0).  
    colors at:6 put:#(255 255 255).   
!

setupPoints
    "
     setup the 6 points:
    "

    points := Array new:6.
    points at:1 put:(Point3D x: 1.0 y: 0.0 z: 0.0).  
    points at:2 put:(Point3D x: 0.0 y: 1.0 z: 0.0).   
    points at:3 put:(Point3D x: 0.0 y: 0.0 z: 1.0).   
    points at:4 put:(Point3D x:-1.0 y: 0.0 z: 0.0).   
    points at:5 put:(Point3D x: 0.0 y:-1.0 z: 0.0).  
    points at:6 put:(Point3D x: 0.0 y: 0.0 z:-1.0).   
!

initialize
    super initialize.

    type := #rgbDoubleBuffer.
    self setupColors.

    transZ := false.
    rotY := true.
    rotX := false.
    rotZ := false.
!

realize
    super realize.

    self zBuffer:true.
! !

!GLOctaHedronDemoView methodsFor:'drawing'!

drawObject
    self czClearColor:0 z:100000. "/ (SmallInteger maxVal min:(device maxZValue)). 
    self zClear.

    self beginTriangleMesh.
    self vertex:1.
    self vertex:2.
    self swapTriangleMesh.
    self vertex:3.
    self swapTriangleMesh.
    self vertex:5.
    self swapTriangleMesh.
    self vertex:6.
    self swapTriangleMesh.
    self vertex:2.
    self vertex:4.
    self vertex:3.
    self swapTriangleMesh.
    self vertex:5.
    self swapTriangleMesh.
    self vertex:6.
    self swapTriangleMesh.
    self vertex:2.
    self endTriangleMesh
!

vertex:index
    |clr|

    clr := colors at:index.
    self colorRed:(clr at:1) green:(clr at:2) blue:(clr at:3) alpha:255.
    self v3f:(points at:index)
! !

