'From Smalltalk/X, Version:2.10.4 on 22-dec-1994 at 12:27:15 pm'!

PatternMenu subclass:#LineMenu
	 instanceVariableNames:''
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Applications-DrawTool'
!

!LineMenu class methodsFor:'documentation'!

documentation
"
    a menu for linewidths. Instead of textual entries,
    it shows bitmaps with short line segments in different widths.

    You can use LineMenus as standing menus - as in:

	|p |

	p := LineMenu lineWidths:#(1 2 5 10 20) 
		   selectors:#value:
			args:#(1 2 5 10 20)
		    receiver:[:val | Transcript showCr:val]
			 for:nil.
	p open.

    Of course, their intented use is as pullDown- and popup-menus:

	|v p|

	v := View new.
	p := LineMenu lineWidths:#(1 2 5 10 20) 
		   selectors:#value:
			args:#(1 2 5 10 20)
		    receiver:[:val | Transcript showCr:val]
			 for:nil.
	v middleButtonMenu:(PopUpMenu forMenu:p).
	v open
"

! !

!LineMenu class methodsFor:'instance creation'!

lineWidths:widths selectors:selectors args:args receiver:anObject for:aTopMenu
    |newMenu nWidths wEach hEach patterns|

    hEach := widths max + 2.
    wEach := 64.
    nWidths := widths size.
    patterns := Array new:nWidths.
    1 to:nWidths do:[:index |
	|bitmap|

	bitmap := Form width:wEach height:hEach depth:1.
	bitmap clear.
	bitmap lineWidth:(widths at:index).
	bitmap displayLineFromX:1 y:(hEach // 2) toX:(wEach - 1) y:(hEach // 2).
	patterns at:index put:bitmap.
    ].
    newMenu := super patterns:patterns selectors:selectors args:args receiver:anObject for:aTopMenu.
    newMenu patternSize:(wEach @ hEach).
    newMenu windowRatio:(1 @ nWidths).
    ^ newMenu
!

lineWidths:widths selectors:selectors receiver:anObject for:aTopMenu
    ^ self lineWidths:widths selectors:selectors args:nil receiver:anObject for:aTopMenu
! !

