'From Smalltalk/X, Version:2.10.4 on 28-feb-1995 at 2:12:01 am'!

InspectorView subclass:#OrderedCollectionInspectorView
	 instanceVariableNames:''
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Interface-Inspector'
!

!OrderedCollectionInspectorView methodsFor:'private'!

fieldMenu
    |labels selectors|

    hasMore ifTrue:[
        labels := #(
                      'inspect'
                      'basicInspect'
                      '-'
                      'remove'
                      '-'
                      'show more'
                   ).

        selectors := #(
                      doInspect 
                      doBasicInspect 
                      nil 
                      removeIndex
                      nil 
                      showMore
                      ).
    ] ifFalse:[
        labels := #(
                      'inspect'
                      'basicInspect'
                      '-'
                      'remove'
"/                      '-'
"/                      'owners'
                   ).

        selectors := #(
                      doInspect 
                      doBasicInspect 
                      nil 
                      removeIndex
"/                      nil
"/                      inspectOwners
                      ).
    ].

    ^ PopUpMenu
          labels:(resources array:labels)
          selectors:selectors
!

fieldList 
    "return a list of names for the selectionlist. Leave hasMore as
     true, if a '...' entry should be added."

    |aList n|

    n := inspectedObject size.
    (n > nShown) ifTrue:[
	n := nShown.
	hasMore := true.
    ].
    aList := OrderedCollection new:n+1.
    aList add:'self'.
    1 to:n do:[:index |
	aList add:(index printString)
    ].
    ^ aList
! !

!OrderedCollectionInspectorView methodsFor:'user interaction'!

removeIndex
    "remove selected item from the collection"

    selectedLine == 1 ifFalse:[
        inspectedObject removeIndex:selectedLine -1.
        selectedLine := nil.
        inspectedObject changed.
        self inspect:inspectedObject. "force list update"
    ]
!

valueAtLine:lineNr
    "helper - return the value of the selected entry"

    |index|

    lineNr == 1 ifTrue:[
        ^ inspectedObject
    ].
    index := lineNr - 1.   "/ skip self
    ^ inspectedObject at:index

!

doInspect
    "user selected inspect-menu entry"

    selectedLine notNil ifTrue:[
        (selectedLine == 1) ifTrue:[
            inspectedObject inspect
        ] ifFalse:[
            (inspectedObject at:selectedLine - 1) inspect
        ].
    ]
!

doAccept:theText
    |value|

    value := Compiler evaluate:theText
                      receiver:inspectedObject 
                     notifying:workspace.

    selectedLine notNil ifTrue:[
        selectedLine == 1 ifFalse:[
            inspectedObject at:selectedLine - 1 put:value.
            inspectedObject changed
        ]
    ].
! !

